import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;

public class Test
{
	private final EntityManagerFactory emf;
	private final EntityManager      em;

	public Test()
	{
		emf = Persistence.createEntityManagerFactory("$objectdb/db/test.odb");
		em = emf.createEntityManager();
	}

	public static void main(String[] args)
	{
		Test t = new Test();
		t.doit();
	}

	public void doit()
	{
		String sbs = "This is a test String";
		StringBuilder sbid=new StringBuilder();
		em.getTransaction().begin();
		for(int i=0;i<Integer.MAX_VALUE;i++)
		{
			TestEntity v = new TestEntity();
			sbid.append(i);
			String id = sbid.toString();
			v.setId(id);
			em.persist(v);
			v.setRemark(sbs);
			if(i % 10 == 0)
			{
				System.out.println("flushing");
				em.flush();
				em.clear();
			}
			System.out.println("i="+i);
			TestEntity t1 = em.find(TestEntity.class, id);
			String rem = t1==null ? null : t1.getRemark();
			if(rem==null || rem.compareTo(sbs)!=0)
			{
				System.out.println("Validate failed for i="+i);
				System.out.println("t1="+t1);
				System.out.println("rem="+rem);
				System.exit(1);
			}
		}
		em.getTransaction().commit();
	}
}